program mapgen;
{$APPTYPE CONSOLE}
uses
  SysUtils, Math;

function HexToInt(HexStr: String): Integer;
begin
  result := StrToInt('$' + HexStr);
end;

var
  F: TextFile;
  X, Y: Integer;
  S: string;
  StartX, StopX, StartY, StopY: Integer;

begin
  if ParamCount = 0 then begin
    WriteLn('MapGen -- (c) 2006 Ales Povalac');
    WriteLn('Zadej souradnice ve tvaru ????000h (napr. 7eb1000h jako "7eb1")');
    Write('X pocatek: '); ReadLn(S);
    StartX := HexToInt(S);
    Write('X konec: '); ReadLn(S);
    StopX := HexToInt(S);
    Write('Y pocatek: '); ReadLn(S);
    StartY := HexToInt(S);
    Write('Y konec: '); ReadLn(S);
    StopY := HexToInt(S);
  end else if ParamCount <> 4 then begin
    WriteLn('mapgen xstart xstop ystart ystop');
    Exit;
  end else begin
    StartX := HexToInt(ParamStr(1));
    StopX := HexToInt(ParamStr(2));
    StartY := HexToInt(ParamStr(3));
    StopY := HexToInt(ParamStr(4));
  end;

  WriteLn(Format('Generuji seznam z %dx%d vyrezu...', [StopX-StartX+1, StopY-StartY+1]));

  AssignFile(F, 'wget_map.dat');
  ReWrite(F);

  for X := StartX to StopX do begin
    for Y := StartY to StopY do begin
      WriteLn(F, LowerCase(Format(
        'http://mapserver.mapy.cz/ophoto/16_%4x000_%4x000',
        [X, Y]
      )));
    end;
  end;

  CloseFile(F);

  Write('Hotovo. Stisknete Enter...'); ReadLn;
end.
